<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Services;

use App\Http\Models\StokkapalModel;
use App\Http\Models\StockhistoryModel;
use App\Http\Models\ItemonhandModel;
use App\Http\Models\ItemModel;
use App\Http\Base\BaseService;
use Carbon\Carbon;
use Illuminate\Support\Facades\DB;

class StokkapalService extends BaseService
{
	/**
     StokkapalService constructor.
	 */
	public function __construct()
	{
		parent::__construct();
		$this->model = new StokkapalModel();
		$this->stockhistory = new StockhistoryModel();
		$this->item = new ItemModel();
	}

	/**
	 *  index function that get all data from database by default
	 *  @return array|static[]
	 */
	public function index()
	{
		return $this->model->getQuery()->get();
	}


	/**
	 *  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
	 *  @param array $input
	 *  @return array
	 */
	public function paging($request)
	{
		$auth = json_decode($request->session()->get('auth'));
		$this->item->getQuery()->select([
			"item.id as itemId",
			"item.namaItem as namaItem",
			"item.deskripsi",
			"item.part_number",
			"item.UOM",
			"item.UOM as total",
			"item.UOM as nLot"
		])
			/* ->selectRaw('SUM("stokkapal"."jumlah") as "total"')
			->selectRaw('COUNT("stokkapal"."itemId") as "nLot"') */
			->where("item.enabled_flex", "=", "Y")
			->where("item.kapalId", "=", $auth->kapalId)
			->where("item.stockable", "=", "Y")
			// ->where("stokkapal.jumlah", ">", 0);
			->whereIn("item.id", function ($query) use ($auth) {
				if ($auth->aplikasi != "HO") {
					$query->select("stokkapal.itemId")
						->from("stokkapal")
						->whereIn("lokasiId", $auth->arrLokasi)
						->where("jumlah", ">", 0)
						->where("kapalId", "=", $auth->kapalId);
				} else {
					$query->select("stokkapal.itemId")
						->from("stokkapal")
						->whereIn("lokasiId", $auth->arrLokasi)
						->where("jumlah", ">", 0);
				}
			});

		$this->item->paging()->filter()->sorting();
		$model = $this->item->paging()->getPaging();

		foreach ($model["rows"] as $idx => $row) {
			if ($auth->aplikasi != "HO") {
				$stokKapal = (new StokkapalModel())->getQuery()->selectRaw('SUM("stokkapal"."jumlah") as "total"')
					->selectRaw('COUNT("stokkapal"."itemId") as "nLot"')
					->where("itemId", "=", $row->itemId)
					->where("stokkapal.jumlah", ">", 0)
					->whereIn("lokasiId", $auth->arrLokasi)
					->where("kapalId", "=", $auth->kapalId)
					->groupBy("itemId")
					->first();
			} else {
				$stokKapal = (new StokkapalModel())->getQuery()->selectRaw('SUM("stokkapal"."jumlah") as "total"')
					->selectRaw('COUNT("stokkapal"."itemId") as "nLot"')
					->where("itemId", "=", $row->itemId)
					->where("stokkapal.jumlah", ">", 0)
					->whereIn("lokasiId", $auth->arrLokasi)
					->groupBy("itemId")
					->first();
			}
			$model["rows"][$idx]->total = $stokKapal->total;
			$model["rows"][$idx]->nLot = $stokKapal->nLot;
		}
		return $model;
	}

	/**
	 *  get one raw row data from table by id
	 *  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
	 *  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
	 *  and you want to take value like this $model->fieldname
	 *  @param $id
	 *  @return StokkapalModel
	 */
	public function show($id)
	{
		$model = $this->model->joinRelationItemId()->joinRelationLokasiId()->getQuery()
			->select([
				"stokkapal.id",
				"stokkapal.itemId",
				"stokkapal.lokasiId",
				"itemId.namaItem",
				"itemId.deskripsi",
				"itemId.part_number",
				"lokasiId.namaLokasi",
				"stokkapal.jumlah",
				"itemId.UOM",
				"stokkapal.status"
			])
			->where("itemId.enabled_flex", "=", "Y")
			->where("stokkapal.id", "=", $id)->first();
		return $model;
	}


	/**
	 *  this is a base function for storing data you with transaction by default
	 *  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
	 *  @param array $input
	 *  @return StokkapalModel
	 *  @throws \Exception
	 */
	public function store($input)
	{
		$this->model->fill($input);
		// $this->model->id = $this->model->getQuery()->orderBy("id", "desc")->first()->id + 1;
		if (!$this->model->save()) {
			throw new \Exception();
		}
		return $this->model;
	}


	/**
	 * this function will delete much data, in one action
	 * the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
	 * you can remove this main alogorithm with your business requirement like soft delete or anything you want
	 *  @param $ids
	 */
	public function delete($ids)
	{
		$params = explode(".", $ids);
		$this->model->deleteBulk("id", $params);
	}


	/**
	 *  this is a base function for update and delete data by default.
	 *  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or 
	 *  you can add multiple relation proses after update in this function 
	 *  @param $id
	 *  @param array $input 
	 *  @return StokkapalModel
	 *  @throws \Exception
	 */
	public function update($id, $input)
	{
		$stokkapal = StokkapalModel::find($id);
		$stokkapal->fill($input);
		if (!$stokkapal->update()) {
			throw new \Exception();
		}
		return $stokkapal;
	}


	/**
	 *  this function will be confirting paging property into file excel
	 *  the main library is base on excel spreadsheet library
	 *  @param array $input
	 *   @return array|static[]
	 */
	public function exportToExcel($input = array())
	{
		return $this->model->getQuery()->get();
	}


	/**
	 *  this is a base function for update stock.
	 *  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or 
	 *  you can add multiple relation proses after update in this function 
	 *  @param array $input 
	 *  @return StokkapalModel
	 *  @throws \Exception
	 */
	public function updateStock($items)
	{
		foreach ($items as $item) {
			$sisaawal = $this->getStockBasedOnItemID($item["kapalId"], $item["itemId"], $item["lokasiId"]);
			$existStock = $this->checkStock($item["kapalId"], $item["itemId"], $item["lokasiId"], $item["lotNumber"]);
			if ($existStock) {
				$jumlahBaru = $existStock->jumlah + $item["jumlah"];
				$this->update($existStock->id, ["jumlah" => $jumlahBaru]);
			} else {
				$store = new StokkapalModel();
				$store->fill($item);
				if (!$store->save()) {
					throw new \Exception();
				}
			}

			$item["mutasi"] 	= "IN";
			$item["stokawal_periode"] 	= date("Y-m-01", strtotime($item["periode"]));
			$item["stokawal"] 	= $this->getItemOnHandBasedOnItemID($item["kapalId"], $item["itemId"], $item["stokawal_periode"], $item["lokasiId"]);
			$item["sisaawal"] 	= $sisaawal;
			$item["sisaakhir"] 	= intval($sisaawal) + intval($item["jumlah"]);
			$item["harga"] 			= intval($item["harga_satuan"] * $item["jumlah"]);
			$item["harga_satuan"] 	= intval($item["harga_satuan"]);

			$this->storeStockHistory($item);
		}
	}

	public function reduceStock($items, $stockHistory = [])
	{
		foreach ($items as $item) {
			$stokKapal = StokkapalModel::where("id", $item->stokId)->first();

			$sisaawal = $this->getStockBasedOnItemID($stokKapal->kapalId, $stokKapal->itemId, $stokKapal->lokasiId);

			if ($stokKapal->jumlah < $item->quantity) {
				throw new \Exception('Item quantity received is not valid.');
			} else {
				$stokKapal->jumlah -= $item->quantity;
				if ($stokKapal->jumlah < 0) {
					$stokKapal->jumlah = 0;
				}
				if (!$stokKapal->update()) {
					throw new \Exception();
				}

				if (!empty($stockHistory)) {
					$stockHistory["itemId"] 	= $stokKapal->itemId;
					$stockHistory["kapalId"] 	= $stokKapal->kapalId;
					$stockHistory["lokasiId"] 	= $stokKapal->lokasiId;
					$stockHistory["jumlah"] 	= $item->quantity * -1;
					$stockHistory["lotNumber"] 	= $stokKapal->lotNumber;
					$stockHistory["mutasi"] 	= "OUT";
					$stockHistory["stokawal_periode"] 	= date("Y-m-01", strtotime($stockHistory["periode"]));
					$stockHistory["stokawal"] 	= $this->getItemOnHandBasedOnItemID($stokKapal->kapalId, $stokKapal->itemId, $stockHistory["stokawal_periode"], $stokKapal->lokasiId);
					$stockHistory["sisaawal"] 	= $sisaawal;
					$stockHistory["sisaakhir"] 	= intval($sisaawal) + $stockHistory["jumlah"];
					$stockHistory["harga"] 				= intval($item->harga_satuan * $stockHistory["jumlah"]);
					$stockHistory["harga_satuan"] 		= intval($item->harga_satuan);
					$this->storeStockHistory($stockHistory);
				}
			}
		}
	}

	public function saveAdjusmentToStockHistory($model)
	{
		$item = (new ItemModel())->where("id", "=", $model->ITEM_ID)->first();
		if ($item->stockable == "Y") {
			$lokasiItemService = new LokasiitemService();
			$lokasiItem = $lokasiItemService->getLokasiByName($model->SUBINVENTORY_CODE);
			if ($lokasiItem) {
				$lokasiId = $lokasiItem->id;
			} else {
				$lokasiId = 0;
			}
			$sisaawal = $this->getStockBasedOnItemID($model->ORGANIZATION_ID, $model->ITEM_ID, $lokasiId);

			$stockHistory["transaksi"] = $model->SOURCE;
			$stockHistory["noTransaksi"] = $model->TRANSACTION_NUM;
			$stockHistory["itemId"] = $model->ITEM_ID;
			$stockHistory["kapalId"] = $model->ORGANIZATION_ID;
			$stockHistory["lokasiId"] = $lokasiId;

			$stockHistory["lotNumber"] = $model->LOT_NUMBER;
			$stockHistory["username"] = "System";
			$stockHistory["periode"] = $model->TRANSACTION_DATE;
			$stockHistory["date_updated"] = Carbon::now()->toDateTimeString();

			if ($model->QTY > 0) {
				$stockHistory["mutasi"] = "IN";
			} else {
				$stockHistory["mutasi"] = "OUT";
			}
			$stockHistory["jumlah"] = floatval($model->QTY);
			$stockHistory["stokawal_periode"] = date("Y-m-01");
			$stokawal = $this->getItemOnHandBasedOnItemID($model->ORGANIZATION_ID, $model->ITEM_ID, $stockHistory["stokawal_periode"], $lokasiId);
			$stockHistory["stokawal"] = floatval($stokawal);
			$stockHistory["sisaawal"] = floatval($sisaawal);
			$stockHistory["sisaakhir"] = intval($sisaawal) + $stockHistory["jumlah"];

			$this->storeStockHistory($stockHistory);
		}
	}

	public function storeStockHistory($stockHistory)
	{
		$store = new StockhistoryModel();
		$store->fill($stockHistory);
		if (!$store->save()) {
			throw new \Exception();
		}
	}

	public function showBasedOnItem($itemId, $auth)
	{
		$this->model->joinRelationKapalId()->joinRelationItemId()->joinRelationLokasiId()->getQuery()
			->select([
				"stokkapal.itemId",
				"stokkapal.lokasiId",
				"stokkapal.jumlah",
				"itemId.UOM",
				"itemId.part_number",
				"itemId.image",
				"stokkapal.status",
				"stokkapal.lotNumber",
				"stokkapal.tglMasuk",
				"itemId.namaItem",
				"itemId.deskripsi",
				"lokasiId.namaLokasi",
				"kapalId.namaKapal"
			])
			->where("stokkapal.jumlah", ">", 0)
			->where("itemId.enabled_flex", "=", "Y")
			->whereIn("stokkapal.lokasiId", $auth->arrLokasi)
			->where("itemId.stockable", "=", "Y")
			->where("stokkapal.itemId", "=", $itemId);

		if ($auth->aplikasi == "HO") {
			$this->model->getQuery()->where("stokkapal.kapalId", "=", $auth->kapalId);
		}

		$model = $this->model->getQuery()->get();
		return $model;
	}

	public function getStokList($request, $type = 1)
	{
		$auth = json_decode($request->session()->get('auth'));

		$input  = $request->all();
		$this->model->joinRelationItemId()->joinRelationLokasiId()->getQuery()
			->select([
				"stokkapal.itemId as itemId",
				"stokkapal.lotNumber",
				"stokkapal.jumlah",
				"stokkapal.tglMasuk",
				"stokkapal.lokasiId",
				"stokkapal.id as stokID",

				"lokasiId.namaLokasi as namaLokasi",

				"itemId.id as id",
				"itemId.namaItem as namaItem",
				"itemId.deskripsi as deskripsi",
				"itemId.category as category",
				"itemId.image as image",
				"itemId.item_price as harga",
				"itemId.part_number",
				"itemId.UOM as UOM"
			])
			->where("stokkapal.jumlah", ">", 0)
			// ->where("stokkapal.type", "=", $type)
			->where("itemId.enabled_flex", "=", "Y")
			->where("itemId.stockable", "=", "Y")
			->where("itemId.kapalId", "=", $auth->kapalId)
			->whereIn("itemId.type_id", $auth->arrCategory)
			->whereIn("stokkapal.lokasiId", $auth->arrLokasi);

		///	 BUAT JAGAIN TIPE ID SAAT
		if ($type == 1) {
			$this->model->getQuery()->where("itemId.type_id", "!=", $auth->sysParams->PELNIMEAL);
		} else {
			$this->model->getQuery()->where("itemId.type_id", "=", $auth->sysParams->PELNIMEAL);
		}

		if ($auth->aplikasi != "HO") {
			$this->model->getQuery()->where("stokkapal.kapalId", "=", $auth->kapalId);
		}
		$this->model->paging()->filter()->sorting();
		return $this->model->paging()->getPaging();
	}

	public function reportStockCard($request, $dateStart, $dateEnd)
	{
		$auth = json_decode($request->session()->get('auth'));
		$input = $request->all();

		$model = $this->stockhistory->joinRelationItemId()->joinRelationLokasiId()->getQuery()
			->select([
				"stockhistory.*",
				"lokasiId.namaLokasi",
				"itemId.namaItem",
				"itemId.deskripsi",
				"itemCategory.category"
			])
			->where("stockhistory.kapalId", "=", $input["kapalId"])
			// ->where("itemId.enabled_flex", "=", "Y")
			->whereIn("itemId.type_id", $auth->arrCategory)
			->where("itemId.type_id", "!=", $auth->sysParams->PELNIMEAL)
			->whereIn("stockhistory.lokasiId", $input["lokasiId"])
			->where("stockhistory.periode", ">=", $dateStart)
			->where("stockhistory.periode", "<=", $dateEnd)
			->orderBy("lokasiId.namaLokasi", "ASC")
			->orderBy("itemId.namaItem", "ASC")
			->orderBy("stockhistory.periode", "ASC")
			//				->orderBy("stockhistory.date_updated", "ASC")
			->orderBy("stockhistory.mutasi", "ASC")
			->get();

		// CEK IN CASE STOK AWAL PADA BULAN TERSEBUT BERBEDA DENGAN DATA DARI ITEM ON HAND KRN ADJUSMENT
		$transaksi = $itemID = $lokasiID = $sisaAkhir = "";
		foreach ($model as $idx => $row) {
			if ($transaksi != $row->transaksi || $itemID != $row->itemId || $lokasiID != $row->lokasiId) {
				$stokAwal = $this->getItemOnHandQtyAwal($input["kapalId"], $row->itemId, $dateStart, $row->namaLokasi);
				if ($stokAwal != $row->stokawal) {
					$model[$idx]->stokawal = $stokAwal;
				}
				$sisaAkhir = $model[$idx]->stokawal;
			}
			$model[$idx]->sisaawal = $sisaAkhir;
			$sisaAkhir = $model[$idx]->sisaakhir = $model[$idx]->stokawal + $row->jumlah;
			$transaksi = $row->transaksi;
			$itemID = $row->itemId;
			$lokasiID = $row->lokasiId;
		}
		return $model;
	}

	public function reportBahanMakanan($request, $dateStart, $dateEnd)
	{
		$auth = json_decode($request->session()->get('auth'));
		$input = $request->all();

		$this->stockhistory->joinRelationItemId()->joinRelationPenggunaanBarang()->joinRelationKapalId()->getQuery()
			->select([
				"stockhistory.*",
				"itemId.namaItem",
				"itemId.deskripsi",
				"itemId.UOM",
				"itemId.item_price",
				"itemCategory.category",
				"kapalId.namaKapal"
			])
			->where("stockhistory.kapalId", "=", $input["kapalId"])
			// ->where("itemId.enabled_flex", "=", "Y")
			->where("itemId.type_id", "=", $auth->sysParams->PELNIFNB)
			->where("stockhistory.transaksi", "=", "penggunaanbarang")
			->where("penggunaanBarang.voyageKode", "=", $input["voyageKode"]);
		if ($input["voyageKode"] <= 0) {
			$this->stockhistory->getQuery()->whereRaw('"penggunaanBarang"."tglPenggunaan" BETWEEN  \'' . $dateStart . '\' AND \'' . $dateEnd . '\' ');
		}

		$model = $this->stockhistory->getQuery()
			/* ->where("stockhistory.periode", ">=", $dateStart)
				->where("stockhistory.periode", "<=", $dateEnd) */
			->orderBy("itemId.namaItem", "ASC")
			// ->orderBy("stockhistory.periode", "ASC")
			->orderBy("stockhistory.date_updated", "ASC")
			->get();
		return $model;
	}

	// CHECK STOCK SUATU ITEM PADA SEBUAH SUBINVENTORY @ KAPAL, DENGAN LOTNUMBER YG TERCANTUM
	public function checkStock($kapalId, $itemID, $lokasiID, $lotNumber)
	{

		$model = (new StokkapalModel())->getQuery()->select("stokkapal.jumlah", "stokkapal.id")
			->where("stokkapal.jumlah", ">", 0)
			->where("stokkapal.kapalId", "=", $kapalId)
			->where("stokkapal.lokasiId", "=", $lokasiID)
			->where("stokkapal.itemId", "=", $itemID)
			->where("stokkapal.lotNumber", "=", $lotNumber)
			->first();

		return $model;
	}

	public function getStockBasedOnItemID($kapalId, $itemID, $lokasiID = 0)
	{
		if ($lokasiID > 0) {
			$model = (new StokkapalModel())->getQuery()->selectRaw(' SUM("stokkapal"."jumlah") as "total", "stokkapal"."itemId" ')
				->where("stokkapal.jumlah", ">", 0)
				->where("stokkapal.kapalId", "=", $kapalId)
				->where("stokkapal.lokasiId", "=", $lokasiID)
				->where("stokkapal.itemId", "=", $itemID)
				->groupBy("stokkapal.itemId")
				->first();
		} else {
			$model = (new StokkapalModel())->getQuery()->selectRaw(' SUM("stokkapal"."jumlah") as "total", "stokkapal"."itemId" ')
				->where("stokkapal.jumlah", ">", 0)
				->where("stokkapal.kapalId", "=", $kapalId)
				->where("stokkapal.itemId", "=", $itemID)
				->groupBy("stokkapal.itemId")
				->first();
		}

		if ($model) {
			return $model->total;
		} else {
			return 0;
		}
	}

	public function getItemOnHandBasedOnItemID($kapalId, $itemID, $periode, $subInv = "")
	{
		$model = new ItemonhandModel();
		$model->getQuery()
			->selectRaw(' SUM("QTY") as "QTY" ')
			->where("ORGANIZATION_ID", "=", $kapalId)
			->where("INVENTORY_ITEM_ID", "=", $itemID)
			->where("PERIOD_START_DATE", "=", date("Y-m-d", strtotime($periode . ' -1 months')));

		if (!empty($subInv) && intval($subInv) > 0) {
			$lokasiItemService = new LokasiitemService();
			$subInventory = $lokasiItemService->show($subInv);
			if ($subInventory) {
				$model->getQuery()->where("SUBINVENTORY_CODE", "=", $subInventory->namaLokasi);
			}
		}
		$itemOnHand = $model->getQuery()->first();

		if ($itemOnHand) {
			return intval($itemOnHand->QTY);
		} else {
			return 0;
		}
	}

	// to get saldo awal, with or without sub inv
	public function getItemOnHandQtyAwal($kapalId, $itemID, $periode, $subInv = "")
	{
		$model = new ItemonhandModel();
		$model->getQuery()
			->selectRaw(' SUM("QTY_AWAL") as "QTY" ')
			->where("ORGANIZATION_ID", "=", $kapalId)
			->where("INVENTORY_ITEM_ID", "=", $itemID)
			->where("PERIOD_START_DATE", "=", date("Y-m-d", strtotime($periode)));

		if (!empty($subInv) && intval($subInv) > 0) {
			$lokasiItemService = new LokasiitemService();
			$subInventory = $lokasiItemService->show($subInv);
			if ($subInventory) {
				$model->getQuery()->where("SUBINVENTORY_CODE", "=", $subInventory->namaLokasi);
			}
		}
		$itemOnHand = $model->getQuery()->first();

		if ($itemOnHand) {
			return intval($itemOnHand->QTY);
		} else {
			return 0;
		}
	}

	/*
	FORMAT ROW = [
		NO, NAMAITEM, PARTNO, SALDOAWAL, PENERIMAAN, PENGGUNAAN, SISA, SATUAN, KETERANGAN
	]
	*/

	public function reportSparePart($request, $dateStart, $dateEnd)
	{
		$auth = json_decode($request->session()->get('auth'));
		$input = $request->all();

		$model = $this->stockhistory->joinRelationItemId()->joinRelationLokasiId()->getQuery()
			->select([
				"stockhistory.*",
				"lokasiId.namaLokasi",
				"itemId.namaItem",
				"itemId.deskripsi",
				"itemId.part_number",
				"itemCategory.category",
				"itemId.UOM",
				"itemId.item_groups",
				"itemId.item_subgroups",
				"itemId.item_subsubgroups"
			])
			->where("stockhistory.kapalId", "=", $input["kapalId"])
			// ->where("itemId.enabled_flex", "=", "Y")
			->whereIn("itemId.type_id", explode(",", $auth->sysParams->SPAREPART))
			// ->whereIn("stockhistory.lokasiId", $input["lokasiId"])
			->where("stockhistory.periode", ">=", $dateStart)
			->where("stockhistory.periode", "<=", $dateEnd)
			->orderBy("itemId.item_groups", "ASC")
			->orderBy("itemId.item_subgroups", "ASC")
			->orderBy("itemId.item_subsubgroups", "ASC")
			->get();

		$romawi = ["I", "II", "III", "IV", "V", "VI", "VII", "VIII", "IX", "X", "XI", "XII", "XIII", "XIV", "XV", "XVI", "XVII", "XVIII", "XIX", "XX"];
		$sparePart = $sparePartItemIds = [];
		$mainCategory = $subCategory = "";
		$mainCategorySeq = 0;
		$subCategorySeq = "A";
		$itemSeq = 1;
		foreach ($model as $row) {
			if ($row->item_groups && $mainCategory != $row->item_groups) {
				$mainCategory = $row->item_groups;
				$subCategory = "A";
				$itemSeq = 1;

				if (!empty($sparePart)) {
					$sparePart[] = ["no" => "", "deskripsiItem" => "", "partNo" => "", "saldoAwal" => "", "penerimaan" => "", "penggunaan" => "", "sisa" => "", "satuan" => "", "keterangan" => ""];
				}
				$sparePart[] = ["no" => "<b>" . $romawi[$mainCategorySeq] . "</b>", "deskripsiItem" => "<b>" . $row->item_groups . "</b>", "partNo" => "", "saldoAwal" => "", "penerimaan" => "", "penggunaan" => "", "sisa" => "", "satuan" => "", "keterangan" => ""];
				$mainCategorySeq++;
			}
			if ($row->item_subgroups && $subCategory != $row->item_subgroups) {
				$subCategory = $row->item_subgroups;
				$itemSeq = 1;
				$sparePart[] = ["no" => "<b>" . $subCategorySeq . "</b>", "deskripsiItem" => "<b>" . $row->item_subgroups . "</b>", "partNo" => "", "saldoAwal" => "", "penerimaan" => "", "penggunaan" => "", "sisa" => "", "satuan" => "", "keterangan" => ""];
				$subCategorySeq++;
			}

			if (!isset($sparePart[$row->itemId])) {
				$sparePart[$row->itemId] = [
					"no" => $itemSeq,
					"deskripsiItem" => $row->deskripsi,
					"partNo" => $row->part_number,
					"saldoAwal" => $this->getItemOnHandBasedOnItemID($input["kapalId"], $row->itemId, $dateStart),
					"penerimaan" => 0,
					"penggunaan" => 0,
					"sisa" => "",
					"satuan" => $row->UOM,
					"keterangan" => ""
				];
				$itemSeq++;
			}

			if ($row->jumlah > 0) {
				$sparePart[$row->itemId]["penerimaan"] += $row->jumlah;
			} else {
				$sparePart[$row->itemId]["penggunaan"] += $row->jumlah;
			}


			$sparePartItemIds[] = $row->itemId;
		}
		return $sparePart;
	}
}
